Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
Botan::Stateful_RNG Class Referenceabstract

`#include <stateful_rng.h>`

Inheritance diagram for Botan::Stateful_RNG:

## Public Member Functions
virtual void | add_entropy (const uint8_t input[], size_t length)=0
template<typename T >
void | add_entropy_T (const T &t)
void | clear () override
void | force_reseed ()
void | initialize_with (const uint8_t input[], size_t length)
bool | is_seeded () const overridefinal
virtual std::string | name () const =0
uint8_t | next_byte ()
uint8_t | next_nonzero_byte ()
secure_vector< uint8_t > | random_vec (size_t bytes)
virtual void | randomize (uint8_t output[], size_t length)=0
virtual void | randomize_with_input (uint8_t output[], size_t output_len, const uint8_t input[], size_t input_len)
void | randomize_with_ts_input (uint8_t output[], size_t output_len) overridefinal
size_t | reseed (Entropy_Sources &srcs, size_t poll_bits=BOTAN_RNG_RESEED_POLL_BITS, std::chrono::milliseconds poll_timeout=BOTAN_RNG_RESEED_DEFAULT_TIMEOUT) override
void | reseed_from_rng (RandomNumberGenerator &rng, size_t poll_bits=BOTAN_RNG_RESEED_POLL_BITS) overridefinal
virtual size_t | security_level () const =0
| Stateful_RNG (RandomNumberGenerator &rng, Entropy_Sources &entropy_sources, size_t reseed_interval)
| Stateful_RNG (RandomNumberGenerator &rng, size_t reseed_interval)
| Stateful_RNG (Entropy_Sources &entropy_sources, size_t reseed_interval)
| Stateful_RNG ()

## Static Public Member Functions
static RandomNumberGenerator * | make_rng ()

## Protected Member Functions
uint32_t | last_pid () const
void | reseed_check ()

## Protected Attributes
size_t | m_reseed_counter = 0

## Detailed Description

Inherited by RNGs which maintain in-process state, like HMAC_DRBG. On Unix these RNGs are vulnerable to problems with fork, where the RNG state is duplicated, and the parent and child process RNGs will produce identical output until one of them reseeds. Stateful_RNG reseeds itself whenever a fork is detected, or after a set number of bytes have been output.

Not implemented by RNGs which access an external RNG, such as the system PRNG or a hardware RNG.

Definition at line 25 of file stateful_rng.h.

## Constructor & Destructor Documentation

Botan::Stateful_RNG::Stateful_RNG | ( | RandomNumberGenerator & | rng,
|  | Entropy_Sources & | entropy_sources,
|  | size_t | reseed_interval
| ) |  |
| inline

Parameters

  rng | is a reference to some RNG which will be used to perform the periodic reseeding
  entropy_sources | will be polled to perform reseeding periodically
  reseed_interval | specifies a limit of how many times the RNG will be called before automatic reseeding is performed

Definition at line 35 of file stateful_rng.h.

37 :
38 m_underlying_rng(&rng),
39 m_entropy_sources(&entropy_sources),
40 m_reseed_interval(reseed_interval)
41 {}

Botan::Stateful_RNG::Stateful_RNG | ( | RandomNumberGenerator & | rng,
|  | size_t | reseed_interval
| ) |  |
| inline

Parameters

  rng | is a reference to some RNG which will be used to perform the periodic reseeding
  reseed_interval | specifies a limit of how many times the RNG will be called before automatic reseeding is performed

Definition at line 49 of file stateful_rng.h.

49 :
50 m_underlying_rng(&rng),
51 m_reseed_interval(reseed_interval)
52 {}

Botan::Stateful_RNG::Stateful_RNG | ( | Entropy_Sources & | entropy_sources,
|  | size_t | reseed_interval
| ) |  |
| inline

Parameters

  entropy_sources | will be polled to perform reseeding periodically
  reseed_interval | specifies a limit of how many times the RNG will be called before automatic reseeding is performed

Definition at line 59 of file stateful_rng.h.

59 :
60 m_entropy_sources(&entropy_sources),
61 m_reseed_interval(reseed_interval)
62 {}

Botan::Stateful_RNG::Stateful_RNG | ( |  | ) |
| inline

In this case, automatic reseeding is impossible

Definition at line 67 of file stateful_rng.h.

67 : m_reseed_interval(0) {}

## Member Function Documentation

virtual void Botan::RandomNumberGenerator::add_entropy | ( | const uint8_t | input[],
|  | size_t | length
| ) |  |
| pure virtual inherited

Incorporate some additional data into the RNG state. For example adding nonces or timestamps from a peer's protocol message can help hedge against VM state rollback attacks. A few RNG types do not accept any externally provided input, in which case this function is a no-op.

Parameters

  input | a byte array containg the entropy to be added
  length | the length of the byte array in

Implemented in Botan::Null_RNG, Botan::HMAC_DRBG, Botan::TPM_RNG, Botan::RDRAND_RNG, Botan::AutoSeeded_RNG, and Botan::System_RNG.

Referenced by Botan::System_RNG::add_entropy(), initialize_with(), Botan::Intel_Rdrand::poll(), Botan::Getentropy::poll(), Botan::Darwin_SecRandom::poll(), Botan::Win32_CAPI_EntropySource::poll(), Botan::Device_EntropySource::poll(), Botan::ProcWalking_EntropySource::poll(), Botan::RandomNumberGenerator::randomize_with_input(), and Botan::RandomNumberGenerator::reseed_from_rng().

template<typename T >

void Botan::RandomNumberGenerator::add_entropy_T | ( | const T & | t | ) |
| inline inherited

Incorporate some additional data into the RNG state.

Definition at line 60 of file rng.h.

Referenced by Botan::Win32_EntropySource::poll().

61 {
62 this->add_entropy(reinterpret_cast<const uint8_t*>(&t), sizeof(T));
63 }
Botan::RandomNumberGenerator::add_entropy
virtual void add_entropy(const uint8_t input[], size_t length)=0

void Botan::Stateful_RNG::clear | ( |  | ) |
| override virtual

Clear all internally held values of this RNG

Postcondition
  is_seeded() == false

Implements Botan::RandomNumberGenerator.

Definition at line 13 of file stateful_rng.cpp.

References m_reseed_counter.

Referenced by Botan::HMAC_DRBG::clear().

14 {
15 m_reseed_counter = 0;
16 m_last_pid = 0;
17 }
Botan::Stateful_RNG::m_reseed_counter
size_t m_reseed_counter
Definition: stateful_rng.h:132

void Botan::Stateful_RNG::force_reseed | ( |  | ) |

Mark state as requiring a reseed on next use

Definition at line 19 of file stateful_rng.cpp.

References m_reseed_counter.

20 {
21 m_reseed_counter = 0;
22 }
Botan::Stateful_RNG::m_reseed_counter
size_t m_reseed_counter
Definition: stateful_rng.h:132

void Botan::Stateful_RNG::initialize_with | ( | const uint8_t | input[],
|  | size_t | length
| ) |  |

Consume this input and mark the RNG as initialized regardless of the length of the input or the current seeded state of the RNG.

Definition at line 29 of file stateful_rng.cpp.

References Botan::RandomNumberGenerator::add_entropy(), m_reseed_counter, and security_level().

30 {
31 add_entropy(input, len);
32
33 if(8*len >= security_level())
34 {
35 m_reseed_counter = 1;
36 }
37 }
Botan::RandomNumberGenerator::add_entropy
virtual void add_entropy(const uint8_t input[], size_t length)=0
Botan::Stateful_RNG::security_level
virtual size_t security_level() const =0
Botan::Stateful_RNG::m_reseed_counter
size_t m_reseed_counter
Definition: stateful_rng.h:132

bool Botan::Stateful_RNG::is_seeded | ( |  | ) | const
| final override virtual

Check whether this RNG is seeded.

Returns
  true if this RNG was already seeded, false otherwise.

Implements Botan::RandomNumberGenerator.

Definition at line 24 of file stateful_rng.cpp.

References m_reseed_counter.

Referenced by reseed_check().

25 {
26 return m_reseed_counter > 0;
27 }
Botan::Stateful_RNG::m_reseed_counter
size_t m_reseed_counter
Definition: stateful_rng.h:132

uint32_t Botan::Stateful_RNG::last_pid | ( |  | ) | const
| inline protected

Definition at line 114 of file stateful_rng.h.

114 { return m_last_pid; }

RandomNumberGenerator * Botan::RandomNumberGenerator::make_rng | ( |  | ) |
| static inherited

Create a seeded and active RNG object for general application use Added in 1.8.0 Use AutoSeeded_RNG instead

Definition at line 51 of file rng.cpp.

52 {
53 #if defined(BOTAN_HAS_AUTO_SEEDING_RNG)
54 return new AutoSeeded_RNG;
55 #else
56 throw Exception("make_rng failed, no AutoSeeded_RNG in this build");
57 #endif
58 }

virtual std::string Botan::RandomNumberGenerator::name | ( |  | ) | const
| pure virtual inherited

Returns
  the name of this RNG type

Implemented in Botan::Null_RNG, Botan::HMAC_DRBG, Botan::TPM_RNG, Botan::RDRAND_RNG, Botan::AutoSeeded_RNG, Botan::PKCS11::PKCS11_RNG, and Botan::System_RNG.

Referenced by Botan::System_RNG::name(), and reseed_check().

uint8_t Botan::RandomNumberGenerator::next_byte | ( |  | ) |
| inline inherited

Return a random byte

Returns
  random byte

Definition at line 144 of file rng.h.

Referenced by Botan::Blinded_Point_Multiply::blinded_multiply(), and Botan::random_prime().

145 {
146 uint8_t b;
147 this->randomize(&b, 1);
148 return b;
149 }
Botan::RandomNumberGenerator::randomize
virtual void randomize(uint8_t output[], size_t length)=0

uint8_t Botan::RandomNumberGenerator::next_nonzero_byte | ( |  | ) |
| inline inherited

Returns
  a random byte that is greater than zero

Definition at line 154 of file rng.h.

155 {
156 uint8_t b = this->next_byte();
157 while(b == 0)
158 b = this->next_byte();
159 return b;
160 }
Botan::RandomNumberGenerator::next_byte
uint8_t next_byte()
Definition: rng.h:144

secure_vector<uint8_t> Botan::RandomNumberGenerator::random_vec | ( | size_t | bytes | ) |
| inline inherited

Return a random vector

Parameters

  bytes | number of bytes in the result

Returns
  randomized vector of length bytes

Definition at line 133 of file rng.h.

Referenced by Botan::CECPQ1_accept(), Botan::CECPQ1_offer(), Botan::TLS::Client_Key_Exchange::Client_Key_Exchange(), Botan::Curve25519_PrivateKey::Curve25519_PrivateKey(), Botan::PK_Decryptor::decrypt_or_random(), Botan::TLS::Session::encrypt(), Botan::KeyPair::encryption_consistency_check(), Botan::generate_bcrypt(), Botan::mceies_encrypt(), Botan::OctetString::OctetString(), Botan::BigInt::randomize(), Botan::TLS::Session_Manager_In_Memory::remove_all(), and Botan::TLS::Session_Manager_SQL::Session_Manager_SQL().

134 {
135 secure_vector<uint8_t> output(bytes);
136 this->randomize(output.data(), output.size());
137 return output;
138 }
Botan::RandomNumberGenerator::randomize
virtual void randomize(uint8_t output[], size_t length)=0

virtual void Botan::RandomNumberGenerator::randomize | ( | uint8_t | output[],
|  | size_t | length
| ) |  |
| pure virtual inherited

Randomize a byte array.

Parameters

  output | the byte array to hold the random output.
  length | the length of the byte array output in bytes.

Implemented in Botan::Null_RNG, Botan::HMAC_DRBG, Botan::TPM_RNG, Botan::RDRAND_RNG, Botan::System_RNG, and Botan::AutoSeeded_RNG.

Referenced by Botan::TLS::Connection_Cipher_State::aead_nonce(), botan_mp_rand_bits(), botan_rng_get(), Botan::CryptoBox::encrypt(), Botan::generate_dsa_primes(), Botan::generate_passhash9(), Botan::TLS::make_hello_random(), Botan::newhope_keygen(), Botan::random_gf2m(), Botan::McEliece_PublicKey::random_plaintext_element(), Botan::System_RNG::randomize(), Botan::RandomNumberGenerator::randomize_with_input(), Botan::RandomNumberGenerator::reseed_from_rng(), Botan::KeyPair::signature_consistency_check(), Botan::RTSS_Share::split(), and Botan::UUID::UUID().

void Botan::RandomNumberGenerator::randomize_with_input | ( | uint8_t | output[],
|  | size_t | output_len,
|  | const uint8_t | input[],
|  | size_t | input_len
| ) |  |
| virtual inherited

Incorporate entropy into the RNG state then produce output. Some RNG types implement this using a single operation, default calls add_entropy + randomize in sequence.

Use this to further bind the outputs to your current process/protocol state. For instance if generating a new key for use in a session, include a session ID or other such value. See NIST SP 800-90 A, B, C series for more ideas.

Parameters

  output | buffer to hold the random output
  output_len | size of the output buffer in bytes
  input | entropy buffer to incorporate
  input_len | size of the input buffer in bytes

Reimplemented in Botan::HMAC_DRBG, and Botan::AutoSeeded_RNG.

Definition at line 30 of file rng.cpp.

References Botan::RandomNumberGenerator::add_entropy(), and Botan::RandomNumberGenerator::randomize().

Referenced by randomize_with_ts_input(), and Botan::RandomNumberGenerator::randomize_with_ts_input().

32 {
33 this->add_entropy(input, input_len);
34 this->randomize(output, output_len);
35 }
Botan::RandomNumberGenerator::add_entropy
virtual void add_entropy(const uint8_t input[], size_t length)=0
Botan::RandomNumberGenerator::randomize
virtual void randomize(uint8_t output[], size_t length)=0

void Botan::Stateful_RNG::randomize_with_ts_input | ( | uint8_t | output[],
|  | size_t | output_len
| ) |  |
| final override virtual

Overrides default implementation and also includes the current process ID and the reseed counter.

Reimplemented from Botan::RandomNumberGenerator.

Definition at line 39 of file stateful_rng.cpp.

References Botan::OS::get_high_resolution_clock(), Botan::OS::get_system_timestamp_ns(), m_reseed_counter, Botan::RandomNumberGenerator::randomize_with_input(), and Botan::store_le().

40 {
41 uint8_t additional_input[24] = { 0 };
42 store_le(OS::get_system_timestamp_ns(), additional_input);
43 store_le(OS::get_high_resolution_clock(), additional_input + 8);
44 store_le(m_last_pid, additional_input + 16);
45 store_le(static_cast<uint32_t>(m_reseed_counter), additional_input + 20);
46
47 randomize_with_input(output, output_len, additional_input, sizeof(additional_input));
48 }
Botan::RandomNumberGenerator::randomize_with_input
virtual void randomize_with_input(uint8_t output[], size_t output_len, const uint8_t input[], size_t input_len)
Definition: rng.cpp:30
Botan::OS::get_system_timestamp_ns
uint64_t BOTAN_DLL get_system_timestamp_ns()
Definition: os_utils.cpp:157
Botan::Stateful_RNG::m_reseed_counter
size_t m_reseed_counter
Definition: stateful_rng.h:132
Botan::store_le
void store_le(uint16_t in, uint8_t out[2])
Definition: loadstor.h:457
Botan::OS::get_high_resolution_clock
uint64_t BOTAN_DLL get_high_resolution_clock()
Definition: os_utils.cpp:109

size_t Botan::Stateful_RNG::reseed | ( | Entropy_Sources & | srcs,
|  | size_t | poll_bits = `BOTAN_RNG_RESEED_POLL_BITS`,
|  | std::chrono::milliseconds | poll_timeout = `BOTAN_RNG_RESEED_DEFAULT_TIMEOUT`
| ) |  |
| override virtual

Poll provided sources for up to poll_bits bits of entropy or until the timeout expires. Returns estimate of the number of bits collected.

Reimplemented from Botan::RandomNumberGenerator.

Definition at line 50 of file stateful_rng.cpp.

References m_reseed_counter, Botan::RandomNumberGenerator::reseed(), and security_level().

Referenced by reseed_check().

53 {
54 size_t bits_collected = RandomNumberGenerator::reseed(srcs, poll_bits, poll_timeout);
55
56 if(bits_collected >= security_level())
57 {
58 m_reseed_counter = 1;
59 }
60
61 return bits_collected;
62 }
Botan::Stateful_RNG::security_level
virtual size_t security_level() const =0
Botan::RandomNumberGenerator::reseed
virtual size_t reseed(Entropy_Sources &srcs, size_t poll_bits=BOTAN_RNG_RESEED_POLL_BITS, std::chrono::milliseconds poll_timeout=BOTAN_RNG_RESEED_DEFAULT_TIMEOUT)
Definition: rng.cpp:37
Botan::Stateful_RNG::m_reseed_counter
size_t m_reseed_counter
Definition: stateful_rng.h:132

void Botan::Stateful_RNG::reseed_check | ( |  | ) |
| protected

Called with lock held

Definition at line 74 of file stateful_rng.cpp.

References BOTAN_ASSERT, Botan::OS::get_process_id(), is_seeded(), m_reseed_counter, Botan::RandomNumberGenerator::name(), reseed(), reseed_from_rng(), and security_level().

Referenced by Botan::HMAC_DRBG::randomize_with_input().

75 {
76 const uint32_t cur_pid = OS::get_process_id();
77
78 const bool fork_detected = (m_last_pid > 0) && (cur_pid != m_last_pid);
79
80 if(is_seeded() == false ||
81 fork_detected ||
82 (m_reseed_interval > 0 && m_reseed_counter >= m_reseed_interval))
83 {
84 m_reseed_counter = 0;
85 m_last_pid = cur_pid;
86
87 if(m_underlying_rng)
88 {
89 reseed_from_rng(*m_underlying_rng, security_level());
90 }
91
92 if(m_entropy_sources)
93 {
94 reseed(*m_entropy_sources, security_level());
95 }
96
97 if(!is_seeded())
98 {
99 if(fork_detected)
100 throw Exception("Detected use of fork but cannot reseed DRBG");
101 else
102 throw PRNG_Unseeded(name());
103 }
104 }
105 else
106 {
107 BOTAN_ASSERT(m_reseed_counter != 0, "RNG is seeded");
108 m_reseed_counter += 1;
109 }
110 }
Botan::OS::get_process_id
uint32_t BOTAN_DLL get_process_id()
Definition: os_utils.cpp:31
Botan::Stateful_RNG::security_level
virtual size_t security_level() const =0
BOTAN_ASSERT
#define BOTAN_ASSERT(expr, assertion_made)
Definition: assert.h:27
Botan::Stateful_RNG::reseed_from_rng
void reseed_from_rng(RandomNumberGenerator &rng, size_t poll_bits=BOTAN_RNG_RESEED_POLL_BITS) overridefinal
Definition: stateful_rng.cpp:64
Botan::RandomNumberGenerator::name
virtual std::string name() const =0
Botan::Stateful_RNG::is_seeded
bool is_seeded() const overridefinal
Definition: stateful_rng.cpp:24
Botan::Stateful_RNG::reseed
size_t reseed(Entropy_Sources &srcs, size_t poll_bits=BOTAN_RNG_RESEED_POLL_BITS, std::chrono::milliseconds poll_timeout=BOTAN_RNG_RESEED_DEFAULT_TIMEOUT) override
Definition: stateful_rng.cpp:50
Botan::Stateful_RNG::m_reseed_counter
size_t m_reseed_counter
Definition: stateful_rng.h:132

void Botan::Stateful_RNG::reseed_from_rng | ( | RandomNumberGenerator & | rng,
|  | size_t | poll_bits = `BOTAN_RNG_RESEED_POLL_BITS`
| ) |  |
| final override virtual

Reseed by reading specified bits from the RNG

Reimplemented from Botan::RandomNumberGenerator.

Definition at line 64 of file stateful_rng.cpp.

References m_reseed_counter, Botan::RandomNumberGenerator::reseed_from_rng(), and security_level().

Referenced by reseed_check().

65 {
66 RandomNumberGenerator::reseed_from_rng(rng, poll_bits);
67
68 if(poll_bits >= security_level())
69 {
70 m_reseed_counter = 1;
71 }
72 }
Botan::Stateful_RNG::security_level
virtual size_t security_level() const =0
Botan::RandomNumberGenerator::reseed_from_rng
virtual void reseed_from_rng(RandomNumberGenerator &rng, size_t poll_bits=BOTAN_RNG_RESEED_POLL_BITS)
Definition: rng.cpp:44
Botan::Stateful_RNG::m_reseed_counter
size_t m_reseed_counter
Definition: stateful_rng.h:132

virtual size_t Botan::Stateful_RNG::security_level | ( |  | ) | const
| pure virtual

Returns
  intended security level of this DRBG

Implemented in Botan::HMAC_DRBG.

Referenced by initialize_with(), reseed(), reseed_check(), and reseed_from_rng().

## Member Data Documentation

size_t Botan::Stateful_RNG::m_reseed_counter = 0
| protected

Definition at line 132 of file stateful_rng.h.

Referenced by Botan::HMAC_DRBG::add_entropy(), clear(), force_reseed(), initialize_with(), is_seeded(), randomize_with_ts_input(), reseed(), reseed_check(), and reseed_from_rng().

The documentation for this class was generated from the following files:

- src/lib/rng/stateful_rng/stateful_rng.h
- src/lib/rng/stateful_rng/stateful_rng.cpp